﻿###########################################
##  BackRaw's Notifications-Script v1.1  ##
##           by BackRaw                  ##
###########################################

import es
import cfglib, gamethread, playerlib, langlib, usermsg

config = cfglib.AddonCFG(es.getAddonPath('notifications') + '/notifications.cfg')

config.text('********************************')
config.text('* Notifications v 1.2 Settings *')
config.text('********************************')
config.text('\n')
config.text('***************')
config.text(' -> WEBSEITE <- ')
config.text('***************')
website_enable = config.cvar('website_enable', 1, 'Website advert on/off')
website = config.cvar('website', 'Website', 'Name of your website here')
config.text('\n')
config.text('**********************************************')
config.text(' -> FRIENDLY FIRE - RATES - MAP - LANGUAGE <- ')
config.text('**********************************************')
ff = config.cvar('ff', 1, '"ff" command on/off - if a player types it in, he sees if it\'s turned on or off')
rate_player = config.cvar('rate_player', 1, '"!rates" command on/off - the player sees what his rates are set to')
player_rates = config.cvar('player_rates', 1, '"showrates" command on/off - everyone sees what the rates of the user who typed it in are set to')
map_player = config.cvar('map_player', 1, '"map" command on/off - shows which map this is')
config.text('\n')
config.text('*********************')
config.text(' -> JOIN - ACTIVE <- ')
config.text('*********************')
player_join = config.cvar('player_join', 1, 'Turns on/off if it should be shown that a player is joining the game')
player_active = config.cvar('player_active', 1, 'Turns on/off if it should be shown that the player is ready for battle')
config.text('\n')
config.text('***************')
config.text(' -> FUNMAPS <- ')
config.text('***************')
funmaps = config.cvar('funmaps', 1, 'Turns on/off if every player should be given the "Assaultsuit" if they spawn on a fun map')
fun_maps = config.cvar('fun_maps', 'Funmaps', 'If the above setting is set to 1, write in your funmaps here (split with ";")')
config.text('\n')
config.text('*********************************************************')
config.text(' -> SELF-HIT - LAST HIT - TEAM ATTACK - KILLER-WEAPON <- ')
config.text('*********************************************************')
hurt_self = config.cvar('hurt_self', 1, 'Turns on/off if the player should be warned, because he/she hurt his-/herself')
last_hit = config.cvar('last_hit', 1, 'Turns on/off if the player should be shown how many damage he\'s given the vitcim with his last hit')
team_attack = config.cvar('team_attack', 1, 'Turns on/off if the player should be warned if he attacks a team mate. Shows how many HP the mate has left, too')
death_weapon = config.cvar('death_weapon', 1, 'Turns on/off if the player should be told what weapon he was killed with and how many HP the attacker has left')
config.text('\n')
config.text('************')
config.text(' -> BOMB <- ')
config.text('************')
bomb_drop_death = config.cvar('bomb_drop_death', 1, 'Turns on/off if the Terrorists should be told that the bomber dropped the bomb because of his death')
bomb_drop = config.cvar('bomb_drop', 1, 'Turns on/off if the Terrorists should be told that the bomb has been thrown away')
bomb_picksup = config.cvar('bomb_picksup', 1, 'Turns on/off if the Terrorists should be told that the bomb has been picked up')
bomb_planting = config.cvar('bomb_planting', 1, 'Turns on/off if the Terrorists should be told that the bomber is planting the bomb')
bomb_has_been_planted = config.cvar('bomb_has_been_planted', 1, 'Turns on/off if the Terrorists should be told that the bomber has planted the bomb successfully')
bomb_defusing = config.cvar('bomb_defusing', 1, 'Turns on/off if the Counter-Terrorists should be told that the bomb is being defused')
bomb_has_been_defused = config.cvar('bomb_has_been_defused', 1, 'Turns on/off if the Counter-Terrorists should be told that the bomb has been defused by defuser')
config.text('\n')
config.text('*******************************')
config.text(' -> BOUGHT WEAPON - FLASHED <- ')
config.text('*******************************')
player_flash_duration = config.cvar('player_flash_duration', 1, 'Turns on/off if the player should be told how long he\'s been flash (in sec) (requires ExtendedEvents)')

config.write()

text = 0
curmap = es.ServerVar('eventscripts_currentmap')
new_weapon_names = {'defuser':'Entschärfungskit', 'knife':'Messer', 'glock':'9x19-MM-Revolver', 'usp':'KM 45, Taktisch', 'p228':'228 (Kompakt)', 'deagle':'Night Hawk .50C', 'fiveseven':'ES Five-Seven', 'elite':'40 Dual Elites', 'ak47':'Avtomat Kalashnikova - 47', 'm4a1':'Maverick M4A1 Karabiner', 'galil':'IDF Defender', 'famas':'FAMAS (Clarion 5.56)', 'sg552':'Kreig 552', 'aug':'Bullpop', 'g3sg1':'D3/AU-1 (G3/SG1)', 'sg550':'Krieg 550 Kommando', 'scout':'Schmidt Scout', 'awp':'Artic Warfare Police', 'mp5navy':'MP5-Navy', 'p90':'ES-C90 (P90)', 'tmp':'Schmidt Maschinenpistole (TMP)', 'ump45':'KM UMP45', 'mac10':'Ingram MAC-10', 'm249':'M249 Para', 'm3':'Leone Kaliber 12 Super (M3)', 'xm1014':'Leone YG1265 Automatik-Schrotgewehr', 'hegrenade':'HE-Granate'}
new_map_names = {'de_dust':'Defusal - Dust', 'de_dust2':'Defusal - Dust2', 'de_aztec':'Defusal - Aztec', 'de_cbble':'Defusal - Cobblestone', 'de_chateau':'Defusal - Castle (Chateau)', 'de_piranesi':'Defusal - Piranesi', 'de_train':'Defusal - Train', 'de_tides':'Defusal - Tides', 'de_port':'Defusal - Port', 'de_inferno':'Defusal - Inferno', 'de_nuke':'Defusal - Nuke', 'de_prodigy':'Defusal - Prodigy', 'cs_italy':'Hostage Rescue - Italy', 'cs_office':'Hostage Rescue - Office', 'cs_havana':'Hostage Rescue - Havana', 'cs_compound':'Hostage Rescue - Compound', 'cs_assault':'Hostage Rescue - Assault', 'cs_militia':'Hostage Rescue - Militia', 'aim_ak-colt':'Aim - AK47 - M4A1', 'he_tennis_2005':'HE - Tennis, 2005'}
round_count = 0

def load():
    global text
    text = langlib.Strings(es.getAddonPath('notifications') + '/langs.ini')
    config.execute()
    if not es.exists('saycommand', '!rates'):
        es.regsaycmd('!rates', 'notifications/rates')
    if not es.exists('saycommand', 'showrates'):
        es.regsaycmd('showrates', 'notifications/showrates')

def unload():
    es.unregsaycmd('!rates')
    es.unregsaycmd('showrates')

def player_say(ev):
    ntext = ev['text']
    if ff == 1:
        if ntext == 'ff':
            if es.ServerVar('mp_friendlyfire') == '1':
                es.msg('#multi', text('ff on'))
            else:
                es.msg('#multi', text('ff off'))
    if map_player == 1:
        if ntext == 'map':
            map_name = str(curmap)
            es.tell(ev['userid'], '#multi', text('map', {'curmap':new_map_names.get(map_name, map_name)}))

def rates():
    if rate_player == 1:
        userid = es.getcmduserid()
        es.tell(userid, '#multi', text('rates are'))
        player_rate = es.getclientvar(userid, 'rate')
        player_cmdrate = es.getclientvar(userid, 'cl_cmdrate')
        player_updaterate = es.getclientvar(userid, 'cl_updaterate')
        gamethread.delayed(.3, es.tell, (userid, '#multi', '#green[#lightgreenNotifications#green] #lightgreenrate: #green%s' % player_rate))
        gamethread.delayed(.3, es.tell, (userid, '#multi', '#green[#lightgreenNotifications#green] #lightgreencl_cmdrate: #green%s' % player_cmdrate))
        gamethread.delayed(.3, es.tell, (userid, '#multi', '#green[#lightgreenNotifications#green] #lightgreencl_updaterate: #green%s' % player_updaterate))

def showrates():
    if player_rates == 1:
        userid = es.getcmduserid()
        es.msg('#multi', text('show rates', {'name':es.getplayername(userid)}))
        player_rate = es.getclientvar(userid, 'rate')
        player_cmdrate = es.getclientvar(userid, 'cl_cmdrate')
        player_updaterate = es.getclientvar(userid, 'cl_updaterate')
        gamethread.delayed(.3, es.msg, ('#multi', '#green[#lightgreenNotifications#green] #lightgreenrate: #green%s' % player_rate))
        gamethread.delayed(.3, es.msg, ('#multi', '#green[#lightgreenNotifications#green] #lightgreencl_cmdrate: #green%s' % player_cmdrate))
        gamethread.delayed(.3, es.msg, ('#multi', '#green[#lightgreenNotifications#green] #lightgreencl_updaterate: #green%s' % player_updaterate))

def round_start(ev):
    global round_count
    round_count += 1
    if website_enable == 1:
        if round_count == 4:
            es.msg('#multi', text('website', {'site':str(website)}))
            round_count = 0

def player_connect(ev):
    if player_join == 1:
        es.msg('#multi', text('joinmsg', {'name':ev['name']}))

def palyer_activate(ev):
    if player_active == 1:
        es.msg('#mutli', text('activemsg', {'name':uname}))

def player_spawn(ev):
    userid = ev['userid']
    map_name = str(curmap)
    if curmap in str(fun_maps).split(';'):
        es.server.cmd('es_xgive %s item_assaultsuit' % userid)
        es.tell(userid, '#multi', text('funmaps', {'map':new_map_names.get(map_name, map_name)}))

def player_hurt(ev):
    attacker = ev['attacker']
    userid = ev['userid']
    uname = ev['es_username']
    uhealth = ev['es_userhealth']
    health = ev['health']
    dmg = ev['dmg_health']
    uteam = ev['es_userteam']
    ateam = ev['es_attackerteam']
    if team_attack == 1:
        if health > '1':
            es.tell(attacker, '#multi', text('team attack', {'name':uname, 'health':uhealth}))
        elif health < '1':
            es.tell(attacker, '#multi', text('team mate down', {'name':uname, 'dmg':dmg}))
    if attacker == userid:
        if hurt_self == 1:
            es.tell(userid, '#multi', text('selfhit'))
    elif uteam != ateam:
        if last_hit == 1:
            if health < '1':
                es.tell(attacker, '#multi', text('last hit', {'name':uname, 'dmg':dmg}))

def player_death(ev):
    attacker = ev['attacker']
    userid = ev['userid']
    aname = ev['es_attackername']
    ahealth = ev['es_attackerhealth']
    if death_weapon == 1:
        weapon = ev['weapon']
        if attacker != userid and weapon != 'world':
            es.tell(userid, '#multi', text('attacker + weapon', {'name':aname, 'weapon':new_weapon_names.get(weapon, weapon)}))
            gamethread.delayed(.3, es.tell, (userid, '#multi', text('attacker health', {'health':ahealth})))
        elif attacker == username and weapon == 'hegrenade':
            es.tell(userid, '#multi', text('nade selfkill'))
        else:
            es.tell(userid, '#multi', text('selfkill'))

def bomb_dropped(ev):
    uhealth = ev['es_userhealth']
    uname = ev['es_username']
    if bomb_drop_death == 1:
        for userid in playerlib.getUseridList('#t'):
            if uhealth < '1':
               es.tell(userid, '#multi', text('killed bomber', {'name':uname}))
            elif bomb_drop == 1 and ev['es_userhealth'] > 1:
                es.tell(userid, '#multi', text('bomb thrown away', {'name':uname}))

def bomb_pickup(ev):
    uname = ev['es_username']
    if bomb_picksup == 1:
        for userid in playerlib.getUseridList('#t'):
            es.tell(userid, '#multi', text('bomb picked up', {'name':uname}))

def bomb_beginplant(ev):
    uname = ev['es_username']
    if bomb_planting == 1:
        for userid in playerlib.getUseridList('#t'):
            es.tell(userid, '#multi', text('bomb planting', {'name':uname}))

def bomb_planted(ev):
    uname = ev['es_username']
    if bomb_has_been_planted == 1:
        for userid in playerlib.getUseridList('#t'):
            es.tell(userid, '#multi', text('bomb planted', {'name':uname}))

def bomb_begindefuse(ev):
    uname = ev['es_username']
    if bomb_defusing == 1:
        for userid in playerlib.getUseridList('#ct'):
            es.tell(userid, '#multi', text('bomb defusing', {'name':uname}))

def bomb_defused(ev):
    uname = ev['es_username']
    if bomb_has_been_defused == 1:
        for userid in playerlib.getUseridList('#ct'):
            es.tell(userid, '#multi', text('bomb defused', {'name':uname}))

def player_flashed(ev):
    duration = ev['duration']
    userid = ev['userid']
    if player_flash_duration == 1:
        if float(ev['duration']) > 1.0:
            gamethread.delayed(float(ev['duration']), usermsg.hudhint, (userid, text('flash duration', {'duration':round(float(duration))})))
        else:
            gamethread.delayed(float(ev['duration']), usermsg.hudhint, (userid, text('flash a sec')))
